;; match.lsp by MacMan 17/7/2002
;; data la variabile globale *predicati*, unifica i predicati
;; in essa presenti con quello passato alla funzione, restituendo
;; le variabili che unificano col parametro.
;; es:
;; > *predicati*
;; ((P a) (Q b) (Q a) (P b) (R c) (P c))
;; > (match '(P ?y))
;; (a b c)
;; (vd. ex 10 del TEs del 6/7/1999)

(format t "~%match.lsp by MacMan 17/7/2002~%")

; funzione match
(format t "function MATCH~%")
(defun match (query)
	(let ((risultati ()))
		(dolist (predicato *predicati*)
			(when (equal (first predicato) (first query))	; Se i predicati combaciano
				(setq risultati (append risultati (last predicato)))
			)
		)
		risultati
	)
)

; definisco *predicati* come nell'esempio
(format t "variabile globale *predicati*~%")
(defvar *predicati* '((P a) (Q b) (Q a) (P b) (R c) (P c)))

